// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'AdvStyleIF.pas' rev: 5.00

#ifndef AdvStyleIFHPP
#define AdvStyleIFHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Registry.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Advstyleif
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TTMSStyle { tsOffice2003Blue, tsOffice2003Silver, tsOffice2003Olive, tsOffice2003Classic, tsOffice2007Luna, 
	tsOffice2007Obsidian, tsWindowsXP, tsWhidbey, tsCustom, tsOffice2007Silver, tsWindowsVista, tsWindows7, 
	tsTerminal, tsOffice2010Blue, tsOffice2010Silver, tsOffice2010Black };
#pragma option pop

#pragma option push -b-
enum XPColorScheme { xpNone, xpBlue, xpGreen, xpGray };
#pragma option pop

#pragma option push -b-
enum TOfficeVersion { ov2003, ov2007, ov2010 };
#pragma option pop

#pragma option push -b-
enum TOfficeTheme { ot2003Blue, ot2003Silver, ot2003Olive, ot2003Classic, ot2007Blue, ot2007Silver, 
	ot2007Black, ot2010Blue, ot2010Silver, ot2010Black, otUnknown };
#pragma option pop

__interface ITMSStyle;
typedef System::DelphiInterface<ITMSStyle> _di_ITMSStyle;
__interface INTERFACE_UUID("{11AC2DDC-C087-4298-AB6E-EA1B5017511B}") ITMSStyle  : public IUnknown 
{
	
public:
	virtual void __fastcall SetComponentStyle(TTMSStyle AStyle) = 0 ;
};

class DELPHICLASS THandleList;
class PASCALIMPLEMENTATION THandleList : public Classes::TList 
{
	typedef Classes::TList inherited;
	
private:
	void __fastcall SetInteger(int Index, int Value);
	int __fastcall GetInteger(int Index);
	
public:
	__fastcall THandleList(void);
	void __fastcall DeleteValue(int Value);
	bool __fastcall HasValue(int Value);
	void __fastcall Assign(Classes::TList* AList);
	__property int Items[int index] = {read=GetInteger, write=SetInteger/*, default*/};
	HIDESBASE void __fastcall Add(int Value);
	HIDESBASE void __fastcall Insert(int Index, int Value);
	HIDESBASE void __fastcall Delete(int Index);
public:
	#pragma option push -w-inl
	/* TList.Destroy */ inline __fastcall virtual ~THandleList(void) { }
	#pragma option pop
	
};


class DELPHICLASS TRegMonitorThread;
class PASCALIMPLEMENTATION TRegMonitorThread : public Classes::TThread 
{
	typedef Classes::TThread inherited;
	
private:
	Registry::TRegistry* FReg;
	int FEvent;
	AnsiString FKey;
	HKEY FRootKey;
	bool FWatchSub;
	int FFilter;
	unsigned FWnd;
	THandleList* FWinList;
	void __fastcall InitThread(void);
	void __fastcall SetFilter(const int Value);
	int __fastcall GetFilter(void);
	
public:
	__fastcall TRegMonitorThread(void);
	__fastcall virtual ~TRegMonitorThread(void);
	void __fastcall Stop(void);
	__property AnsiString Key = {read=FKey, write=FKey};
	__property HKEY RootKey = {read=FRootKey, write=FRootKey, nodefault};
	__property bool WatchSub = {read=FWatchSub, write=FWatchSub, nodefault};
	__property int Filter = {read=GetFilter, write=SetFilter, nodefault};
	__property unsigned Wnd = {read=FWnd, write=FWnd, nodefault};
	__property THandleList* WinList = {read=FWinList};
	
protected:
	virtual void __fastcall Execute(void);
};


class DELPHICLASS TThemeNotifierWindow;
class PASCALIMPLEMENTATION TThemeNotifierWindow : public Controls::TWinControl 
{
	typedef Controls::TWinControl inherited;
	
private:
	Classes::TNotifyEvent FOnOfficeThemeChange;
	
protected:
	virtual void __fastcall WndProc(Messages::TMessage &Msg);
	
__published:
	__property Classes::TNotifyEvent OnOfficeThemeChange = {read=FOnOfficeThemeChange, write=FOnOfficeThemeChange
		};
public:
	#pragma option push -w-inl
	/* TWinControl.Create */ inline __fastcall virtual TThemeNotifierWindow(Classes::TComponent* AOwner
		) : Controls::TWinControl(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TThemeNotifierWindow(HWND ParentWindow) : Controls::TWinControl(
		ParentWindow) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TWinControl.Destroy */ inline __fastcall virtual ~TThemeNotifierWindow(void) { }
	#pragma option pop
	
};


class DELPHICLASS TThemeNotifier;
class PASCALIMPLEMENTATION TThemeNotifier : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	TRegMonitorThread* RegMonitorThread;
	TThemeNotifierWindow* FNotifier;
	Classes::TNotifyEvent FOnOfficeThemeChange;
	
protected:
	void __fastcall OfficeThemeChanged(System::TObject* Sender);
	
public:
	__fastcall virtual TThemeNotifier(Classes::TComponent* AOwner);
	__fastcall virtual ~TThemeNotifier(void);
	void __fastcall RegisterWindow(unsigned Hwnd);
	void __fastcall UnRegisterWindow(unsigned Hwnd);
	
__published:
	__property Classes::TNotifyEvent OnOfficeThemeChange = {read=FOnOfficeThemeChange, write=FOnOfficeThemeChange
		};
};


//-- var, const, procedure ---------------------------------------------------
static const Word WM_OFFICETHEMECHANGED = 0xbb1;
static const Word WM_THEMECHANGED = 0x31a;
extern "C" int __stdcall RegNotifyChangeKeyValue(HKEY hKey, unsigned bWatchSubtree, unsigned dwNotifyFilter
	, unsigned hEvent, unsigned fAsynchronus);
extern PACKAGE TThemeNotifier* ThemeNotifierInstance;
extern PACKAGE bool __fastcall IsThemedApp(void);
extern PACKAGE bool __fastcall IsVista(void);
extern PACKAGE TOfficeVersion __fastcall GetOfficeVersion(void);
extern PACKAGE TOfficeTheme __fastcall GetOfficeTheme(void);
extern PACKAGE TThemeNotifier* __fastcall ThemeNotifier(Controls::TWinControl* AParent);

}	/* namespace Advstyleif */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Advstyleif;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// AdvStyleIF
